﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

class ModelLoader
{

	public ModelLoader() 
	{
	
	}


	public GameObject LoadModel(string fileName, Material mat) 
	{
		/*
		//tetrahedron
		
		Vector3 p0 = new Vector3(0, 0, 0);
		Vector3 p1 = new Vector3(1, 0, 0);
		Vector3 p2 = new Vector3(0.5f, 0, Mathf.Sqrt(0.75f));
		Vector3 p3 = new Vector3(0.5f, Mathf.Sqrt(0.75f), Mathf.Sqrt(0.75f) / 3);

		
		Vector3[] vertices = new Vector3[]{
			p0,p1,p2,
			p0,p2,p3,
			p2,p1,p3,
			p0,p3,p1
		};
		int[] triangles = new int[]{
			0,1,2,
			3,4,5,
			6,7,8,
			9,10,11
		};

		*/
		ObjParser.Obj obj = new ObjParser.Obj();
		obj.LoadObj(fileName);


		Vector3[] vertices = new Vector3[obj.VertexList.Count];
		int[] triangles = new int[obj.FaceList.Count * 3];

		for (int i = 0; i < vertices.Length; i++) 
		{
			vertices[i].x = (float)obj.VertexList[i].X;
			vertices[i].y = (float)obj.VertexList[i].Y;
			vertices[i].z = (float)obj.VertexList[i].Z;			
		}

		
		for (int i = 0; i < triangles.Length; i += 3)
		{

			triangles[i + 0] = obj.FaceList[i / 3].VertexIndexList[0] - 1;
			triangles[i + 1] = obj.FaceList[i / 3].VertexIndexList[1] - 1;
			triangles[i + 2] = obj.FaceList[i / 3].VertexIndexList[2] - 1;

			
		}

		GameObject go = this.CreateGameObject(fileName, mat, vertices, triangles);

		return go;
	}


	private GameObject CreateGameObject(string name, Material mat, Vector3[] vertices, int[] triangles) 
	{
		GameObject go = new GameObject(name);

		go.transform.position = Vector3.zero;
		go.transform.rotation = Quaternion.identity;

		
		MeshFilter mf = go.AddComponent<MeshFilter>();



		mf.sharedMesh = new Mesh();
		mf.sharedMesh.name = "LoadedMesh: " + name;


		mf.sharedMesh.vertices = vertices;
		mf.sharedMesh.triangles = triangles;
	

		mf.sharedMesh.Optimize();

		mf.sharedMesh.RecalculateNormals();
		mf.sharedMesh.RecalculateBounds();

		mf.sharedMesh.Optimize();
		
		
		MeshRenderer mr = go.AddComponent<MeshRenderer>();

		Shader shader = Shader.Find("Custom/CullOff");
		
		mr.sharedMaterial = new Material(mat); ;
		//mr.materials = new Material[1];
		//mr.materials[0] = new Material(mat);

		return go;
	}

	


}
